AppTitle "Super Stick Demo"
SeedRnd MilliSecs()

Graphics 800,600
SetBuffer BackBuffer()

Global AniTimer,ANIMSPEED#=100
Global ColTimer
Global sndHit,sndSwish,sndDrop,sndYa,sndYa2,sndGong,sndMee,sndTick,sndGdbye
Global imgR,imgFight,imgKO,imgTitle,imgStickFace,imgInputs
Global imgButtons,imgHands,imgYesNo,imgFlags,imgVS,imgTally
Global GameMode=0,Bouts=2,BattlePower=2,GoreLevel=3
Global GameTimer
Global fntBig,fntSmall,fntMedium

Include "Include.bb"

Type Player
	Field manx#,offmanx#			;x-coordinate of man
	Field oldx#,newx#,oldy#,newy#	;Used to work out HitAngle
	Field many						;y-position of man
	Field ChargeUp$,ChargeDie		;For working out combo moves
	Field lr						;Right = 1, Left = -1
	Field nextfr.fram				;Next frame to be played
	Field HitAngle#					;Direction of punch/kick
	Field ID						;Player Number
	Field Life#,LifeBar#			;Health Bar
	Field lifeTimer					;For 'Health chunk' timing
	Field hitTimer,throwTimer		;Stops "hit" sounds from playing too much, and can't throw while already throwing
	Field swshTimer					;Stops "swish" sounds from playing too much
	Field Replay.fram[40]			;Holds frame history for ACTION REPLAY!!
	Field ReplX[40],ReplLR[40]		;Holds position history for ACTION REPLAY!!
	Field rpl,rpllast				;Replay List Index number
	Field voice
	Field Wins
	Field Control					;Keys, Joystick, AI...
	Field Name$,Avatar				;Player name and picture
End Type

Type Particle
	Field x#,y#,xspeed#,yspeed#,goresize#
End Type

Global anisize#=1

Dim KVal(10,2,5)
Dim Let#(25,21)

Dim Files$(100)

Const FD=0
Const BK=1
Const UP=2
Const DN=3
Const F1=4
Const F2=5
Const F3=6

Const CNTRL_KEY=1,CNTRL_JOY=2,CNTRL_AI=3

Const GAME_PREFIGHT	=0
Const GAME_FIGHT	=1
Const GAME_PLAY		=2
Const GAME_DIE		=3
Const GAME_REPLAY	=4
Const GAME_END		=5
Load_Media()
Init_Keys()

Title()
f=WriteFile("config.dat")
WriteByte (f,bouts)
WriteByte (f,gorelevel)
WriteByte (f,battlepower)
CloseFile f

End

Function Title()
	endme=0
	selected=1
	titletimer=MilliSecs()
	While endme=0
		If KeyHit(1) Then endme=1
		If KeyHit(200) Then
			selected=selected-1:If selected=0 Then selected=3
			PlaySound sndMee
		ElseIf KeyHit(208) Then
			selected=selected+1:If selected=4 Then selected=1
			PlaySound sndMee
		End If
		If KeyHit(28) Or KeyHit(57)
			Select selected
			Case 1
				chnHit=PlaySound(sndHit)
				ChannelPitch chnHit,Rand(8000,12000)
				New_Game()
			Case 2
				chnHit=PlaySound(sndHit)
				ChannelPitch chnHit,Rand(8000,12000)
				Options()
			Case 3
				chnGdBye=PlaySound(sndGdBye)
				ChannelPitch chnGdBye,28000
				endme=2
			End Select
		End If
		ClsColor 255,255,255
		Cls
		If MilliSecs()-titletimer<=500
			DrawBlock imgTitle,400-ImageWidth(imgTitle)/2,-200+(MilliSecs()-titletimer)/2
		Else
			DrawBlock imgTitle,400-ImageWidth(imgTitle)/2,50
			If (MilliSecs()-titletimer) Mod 50 >25
				randomit=randomit+1
			Else
				randomit=0
			End If
			If randomit=1
				randomit=2
				x=Rand(-1,1):y=Rand(-1,1)
			End If
			For i=1 To 3
				If selected=i Then DrawBlock imgButtons,400+x,250+i*70+y,i-1
				If selected<>i Then DrawBlock imgButtons,400,250+i*70,i-1
			Next
			If (MilliSecs()-titletimer) Mod 400 > 200
				xx=10-((MilliSecs()-titletimer) Mod 400)/40
			Else
				xx=((MilliSecs()-titletimer) Mod 400)/40
			End If
			DrawBlock imgHands,250-xx,250+selected*70,0
			DrawBlock imgHands,550+xx,250+selected*70,1
		End If
		
		Flip
	Wend
	If endme=2 Then
		titletimer=MilliSecs()
		While MilliSecs()-titletimer<=500
			Cls
			DrawBlock imgTitle,400-ImageWidth(imgTitle)/2,50-(MilliSecs()-titletimer)/2
			Flip
		Wend
	End If
End Function

Function Options()
	endme=0
	selected=1
	goreopt=gorelevel
	battleopt=battlepower
	boutopt=bouts
	FlushKeys
	While endme=0
		If KeyHit(1) Then endme=1
		If KeyHit(200) Then
			selected=selected-1:If selected=0 Then selected=3
			PlaySound sndMee
		ElseIf KeyHit(208) Then
			selected=selected+1:If selected=4 Then selected=1
			PlaySound sndMee
		End If
		If KeyHit(205)
			If selected=1 Then boutopt=boutopt+1:If boutopt>5 Then boutopt=1
			If selected=2 Then battleopt=battleopt+1:If battleopt>5 Then battleopt=1
			If selected=3 Then goreopt=goreopt+1:If goreopt>5 Then goreopt=1
			PlaySound sndTick
		ElseIf KeyHit(203)
			If selected=1 Then boutopt=boutopt-1:If boutopt<1 Then boutopt=5
			If selected=2 Then battleopt=battleopt-1:If battleopt<1 Then battleopt=5
			If selected=3 Then goreopt=goreopt-1:If goreopt<1 Then goreopt=5
			PlaySound sndTick
		End If
		
		If KeyHit(28) Or KeyHit(57)
			chnHit=PlaySound(sndHit)
			ChannelPitch chnHit,Rand(8000,12000)
			battlepower=battleopt
			bouts=boutopt
			gorelevel=goreopt
			endme=1
		End If
		Cls
		DrawBlock imgTitle,400-ImageWidth(imgTitle)/2,50
		If (MilliSecs()-titletimer) Mod 50 >25
			randomit=randomit+1
		Else
			randomit=0
		End If
		If randomit=1
			randomit=2
			x=Rand(-1,1):y=Rand(-1,1)
		End If
		For i=1 To 3
			If selected=i Then DrawBlock imgButtons,350+x,250+i*70+y,i+2
			If selected<>i Then DrawBlock imgButtons,350,250+i*70,i+2
		Next
		DrawBlock imgTally,550,320,boutopt-1
		DrawBlock imgTally,550,390,battleopt-1
		DrawBlock imgTally,550,460,goreopt-1

		If (MilliSecs()-titletimer) Mod 400 > 200
			xx=10-((MilliSecs()-titletimer) Mod 400)/40
		Else
			xx=((MilliSecs()-titletimer) Mod 400)/40
		End If
		DrawBlock imgHands,200-xx,250+selected*70,0
		Flip
	Wend
End Function

Function New_Game()
	Dim Files$(100)
	myDir=ReadDir(CurrentDir()+"\stickies")
	j=0
	For i=0 To 100
		file$=NextFile(myDir)
		If file$="" Then Exit
		If FileType(CurrentDir()+"\stickies\"+file$)=1 And Len(file$)>3 Then
			If Upper(Right(file$,4))=".STK" Then
				files$(j)=file$
				j=j+1
			End If
		End If
	Next
	CloseDir myDir
	totalfiles=j
	endme=0
	offx=0:filesel=0:inputsel=0:picsel=0
	offavy=0:offinpy=0
	If totalfiles=0 Then endme=1
	playernum=1
	While endme=0
		If KeyHit(1) Then endme=1
		Cls
		If KeyDown(205) And offx=0
			offx=-1
			pushtime=MilliSecs()
			PlaySound sndMee
		ElseIf KeyDown(203) And offx=0
			offx=1
			pushtime=MilliSecs()
			PlaySound sndMee
		ElseIf KeyDown(200) And offavy=0
			offavy=-1
			avtime=MilliSecs()
			PlaySound sndTick
		ElseIf KeyDown(208) And offinpy=0
			offinpy=1
			inptime=MilliSecs()
			PlaySound sndTick
		End If
		If KeyHit(28) And offx=0 And offavy=0 And offinpy=0 Then
			Load_Stickie(Left(files(filesel),Len(files(filesel))-4))
			pl.player  = create_player("Player " + playernum)
			pl\control = inputsel+1
			pl\avatar = picsel
			offavy=-1:offinpy=1
			offx=-1
			avtime=MilliSecs()
			inptime=MilliSecs()
			pushtime=MilliSecs()
			playernum=playernum+1
			chnHit=PlaySound(sndHit)
			ChannelPitch chnHit,Rand(8000,12000)
			If playernum=3 Then endme=2
		End If
		
		If offx<0 Then
			If (pushtime-MilliSecs())/2<0 Then offx=(pushtime-MilliSecs())/2
			If offx<=-100 Then
				offx=0
				filesel=filesel-1
				If filesel<0 Then filesel=totalfiles-1
			End If
		ElseIf offx>0 Then
			If (MilliSecs()-pushtime)/2>0 Then offx=(MilliSecs()-pushtime)/2
			If offx=>100 Then
				offx=0
				filesel=filesel+1
				If filesel=>totalfiles Then filesel=0
			End If
		End If
		If offavy<>0 Then
			If (avtime-MilliSecs())/2<0 Then offavy=(avtime-MilliSecs())/2
			If offavy<=-128 Then
				offavy=0
				picsel=picsel+1:If picsel=4 Then picsel=0
			End If
		End If
		If offinpy<>0 Then
			If (MilliSecs()-inptime)/2>0 Then offinpy=(MilliSecs()-inptime)/2
			If offinpy>=128 Then
				offinpy=0
				inputsel=inputsel+1:If inputsel=3 Then inputsel=0
			End If
		End If
		
		Viewport 0,300,800,30
		Color 200,200,200
		Rect 0,300,800,30
		Color 0,0,0
		i=filesel:x=400
		SetFont fntSmall
		While x<=900
			Viewport x+offx-48,315-13,96,26
			Color 225,225,225
			Rect x+offx-50,300,100,30
			Color 0,0,0
			Text x+offx,315,Left(files(i),Len(files(i))-4),True,True
			x=x+100
			i=i+1:If i=totalfiles Then i=0
		Wend
		i=filesel:x=400
		While x=>-100
			Viewport x+offx-48,315-13,96,26
			Color 225,225,225
			Rect x+offx-50,300,100,30
			Color 0,0,0
			Text x+offx,315,Left(files(i),Len(files(i))-4),True,True
			x=x-100
			i=i-1:If i=-1 Then i=totalfiles-1
		Wend
		Viewport 0,0,GraphicsWidth(),GraphicsHeight()
		Line 0,300,800,300
		Line 0,329,800,329
		Color 180,180,180
		Rect 400-63,250-127,128,128
		Rect 400-63,381,128,128
		Rect 400-62,250-126,128,128
		Rect 400-62,382,128,128
		Line 0,250-64,GraphicsWidth(),250-64
		Line 0,380+64,GraphicsWidth(),380+64
		Line 0,250-63,GraphicsWidth(),250-63
		Line 0,380+63,GraphicsWidth(),380+63
		SetFont fntBig
		Text 200,250-64,"AVATAR",True,True
		Text 600,250-64,"AVATAR",True,True
		Text 200,380+64,"INPUT",True,True
		Text 600,380+64,"INPUT",True,True
		Color 0,0,0
		Rect 350,298,100,34,0
		Rect 399,250,2,48
		Rect 399,332,2,48
		Viewport 400-64,250-128,128,128
		DrawBlock imgStickFace,400-64,250-128+offavy,picsel
		i=picsel+1:If i=4 Then i=0
		DrawBlock imgStickFace,400-64,250+offavy,i
		Viewport 400-64,380,128,128
		DrawBlock imgInputs,400-64,380+offinpy,inputsel
		i=inputsel+1:If i=3 Then i=0
		DrawBlock imgInputs,400-64,380-128+offinpy,i
		Viewport 0,0,GraphicsWidth(),GraphicsHeight()
		Rect 400-64,250-128,128,128,0
		Rect 400-64,380,128,128,0
		Text 400,50,"Player " + playernum,True,True
		SetFont fntMedium
		Text 400,540,"Use Cursor Keys to select your Stickman.",True,True
		Text 400,560,"Press RETURN when finished.",True,True
		Flip
	Wend
	
	FlushKeys
	FlushJoy
	If endme=2 Then
		pushtimer=MilliSecs()
		While endme=2
			Cls
			DrawBlock imgVS,0,0
			Color 0,0,0
			If MilliSecs()-pushtimer<500
				pl.player = First player
				DrawImage imgStickFace,850-(MilliSecs()-pushtimer)*1.6,50,pl\avatar
				pl.player = After First player
				DrawImage imgStickFace,-50-ImageWidth(imgStickFace)+(MilliSecs()-pushtimer)*1.6,550-ImageHeight(imgStickFace),pl\avatar
				Rect -50-ImageWidth(imgStickFace)+(MilliSecs()-pushtimer)*1.6,550-ImageHeight(imgStickFace),128,128,0
				Rect 850-(MilliSecs()-pushtimer)*1.6,50,128,128,0
			Else
				pl.player = First player
				DrawImage imgStickFace,50,50,pl\avatar
				pl.player = After First player
				DrawImage imgStickFace,750-ImageWidth(imgStickFace),550-ImageHeight(imgStickFace),pl\avatar
				Rect 50,50,128,128,0
				Rect 750-ImageWidth(imgStickFace),550-ImageHeight(imgStickFace),128,128,0
			End If
			If GetKey() Or GetJoy() Then endme=3
			Flip
		Wend
		FlushKeys
		FlushJoy
		gameresult=Game()
		If gameresult=2 Then
			For pl.player = Each player
				If pl\wins=bouts Then
					Restore MessageData
					Read msgnum
					i=Rand(pl\avatar*2,pl\avatar*2+msgnum-1)
					For j=0 To i
						Read WinMessage$
					Next
				Else
					pl\avatar=pl\avatar+4
				End If
			Next
			WinMessage$=Chr(34)+winmessage$+Chr(34)
			pushtimer=MilliSecs()
			texttimer=MilliSecs()
			endme=0
			While endme=0
				Cls
				Color 0,0,0
				Rect 0,0,GraphicsWidth(),GraphicsHeight()
				If MilliSecs()-pushtimer<500
					plb.player = First player
					DrawImage imgStickFace,880-(MilliSecs()-pushtimer)*1.6,80,plb\avatar
					plb.player = After First player
					DrawImage imgStickFace,-80-ImageWidth(imgStickFace)+(MilliSecs()-pushtimer)*1.6,80,plb\avatar
					Rect -80-ImageWidth(imgStickFace)+(MilliSecs()-pushtimer)*1.6,80,128,128,0
					Rect 880-(MilliSecs()-pushtimer)*1.6,50,128,128,0
				Else
					plb.player = First player
					DrawImage imgStickFace,80,80,plb\avatar
					plb.player = After First player
					DrawImage imgStickFace,720-ImageWidth(imgStickFace),80,plb\avatar
					Rect 80,80,128,128,0
					Rect 720-ImageWidth(imgStickFace),80,128,128,0
					If GetKey() Or GetJoy() Then endme=1
				End If
				textlen=(MilliSecs()-texttimer)/10:If textlen>Len(winmessage) Then textlen=Len(winmessage)
				Color 255,255,128
				Rect 0,300,800,2
				SetFont fntMedium
				Color 128,128,128
				Text 401-StringWidth(winmessage)/2,451,Left(WinMessage,textlen),False,True
				Color 255,255,255
				Text 400-StringWidth(winmessage)/2,450,Left(WinMessage,textlen),False,True
				Flip
			Wend
		End If
		FlushKeys
		FlushJoy
	End If
	
	Delete Each player
	Delete Each fram
	Delete Each anim

End Function

Function Game()
	GameTimer=MilliSecs()
	GameMode=Game_PREFIGHT
	PlaySound sndGong
	endme=0
	While endme=0
		If KeyHit(1) Then endme=1
		ClsColor 255,255,255
		Cls
		Color 0,0,0
		Origin 0,0
		If GameMode=GAME_PREFIGHT Then
			If MilliSecs()-GameTimer>800
				GameTimer=MilliSecs()
				GameMode=GAME_FIGHT
			End If
		ElseIf GameMode=GAME_FIGHT
			DrawImage imgFight,400,200
			If MilliSecs()-GameTimer>1200
				GameMode=GAME_PLAY
			End If
		ElseIf gamemode=GAME_DIE Then
			If MilliSecs()-Gametimer>3500
				FlushKeys()
				FlushJoy()
				GameMode=GAME_REPLAY
				For pl.player = Each player
					pl\rpllast=pl\rpl
					pl\rpl=pl\rpl+1
					If pl\rpl>40 Then pl\rpl=0
				Next
			End If
		ElseIf GameMode=GAME_REPLAY Then
			ANIMSPEED=300
			For pl.player = Each player
				If pl\rpl=pl\rpllast-1 Or (pl\rpllast=0 And pl\rpl=30) Then
					GameMode=GAME_END
				End If
			Next
		ElseIf GameMode=GAME_END
			GameMode=GAME_PREFIGHT
			For ani.anim = Each anim
				ani\selected=False
			Next
			For fr.fram = Each fram
				fr\selected=False
			Next
			
			For pl.player = Each player
				If pl\wins=>bouts Then endme=2
			Next
			ANIMSPEED=100
			If endme<>2 Then
				PlaySound sndGong
				For pl.player = Each player
					pl\many=200
					pl\manx=200+400*(pl\ID-1)
					pl\life=300
					pl\lr=(pl\ID Mod 2)*2-1
					pl\rpl=0:pl\offmanx=0
					pl\chargeup$="":pl\chargedie=0
					GameTimer=MilliSecs()
					For ani.anim = Each anim
						If ani\player=pl\ID And ani\name="bow" Then
							ani\selected = True
							For fr.fram = Each fram
								If fr\parent = ani\ID Then
									fr\selected=True
									pl\nextfr.fram = Get_NextFrame(fr,ani,pl)
									Exit
								End If
							Next
						End If
					Next
				Next
			End If
			FlushKeys()
			FlushJoy()
		End If
		
		If GameMode=GAME_DIE Then
			If ANIMSPEED<200 Then ANIMSPEED=ANIMSPEED+8
		End If
		
		;----- G3T K3Y 3V3|\|T5 -----
		For pl.player = Each player
			If GameMode=GAME_PLAY Then Get_KeyEvents(pl)
			If GameMode=GAME_REPLAY Then
				If (GetKey() Or GetJoy()) Then GameMode=GAME_END
			End If
			If pl\manx<=-30 Then pl\manx=830+pl\manx:pl\replx[pl\rpl]=pl\manx
			If pl\manx>=830 Then pl\manx=830-pl\manx:pl\replx[pl\rpl]=pl\manx
		Next
	
		If MilliSecs()-anitimer=>ANIMSPEED Then
			anitimer=MilliSecs()
			For pl.player = Each player
				For ani.anim = Each anim
					If ani\player=pl\ID And ani\selected
						For fr.fram = Each fram
							If fr\selected And fr\parent = ani\ID
								;Handle the Frame information, once per frame change..
								
								fr\selected=False
								ani\selected=False
								pl\nextfr\selected=True
								fr=pl\nextfr
								For anib.anim = Each anim
									If anib\ID = pl\nextfr\parent And anib\player=pl\ID Then anib\selected=True:Exit
								Next
								If GameMode=GAME_REPLAY Then
									pl\manx=pl\replx[pl\rpl]
									pl\lr=pl\repllr[pl\rpl]
									pl\rpl=pl\rpl+1
									If pl\rpl>40 Then pl\rpl=0
									pl\nextfr.fram = pl\replay.fram[pl\rpl]
								Else
									pl\nextfr.fram = Get_NextFrame(pl\nextfr,anib,pl)
								End If
								
								If fr\actpnt>0 Then
									If MilliSecs()-pl\swshTimer>ANIMSPEED*2.5 And ani\name<>"fallback" And ani\name<>"thrown" And ani\name<>"getup" And ani\name<>"flipup" Then
										pl\swshTimer=MilliSecs()
										chnSwish=PlaySound(sndSwish)
										ChannelPitch chnSwish,Rand(14000,24000)*100/((ANIMSPEED-100)/6+100)
										If fr\py[0]<0 Then
											i=Rand(4)
											If i=1 Then
												chnYa=PlaySound(sndYa)
												ChannelPitch chnYa,pl\voice+Rand(-2000,2000)*100/((ANIMSPEED-100)/6+100)
											ElseIf i=2 Then
												chnYa2=PlaySound(sndYa2)
												ChannelPitch chnYa2,pl\voice+Rand(-2000,2000)*100/((ANIMSPEED-100)/6+100)
											End If
										End If
									End If
								End If

								
								If (ani\name="fallback" Or ani\name="thrown" Or ani\name="flipup" Or ani\name="getup") And fr\actpnt>0
									chnDrop=PlaySound(sndDrop)
									ChannelPitch chnDrop,Rand(18000,24000)*100/((ANIMSPEED-100)/6+100)
								End If
		
	
								;C4lcu1473 th3 4|\|613 0f hi77in6, t0 kr3473 6OOd P4r7ikl3 FX
								If fr\actpnt>0 And pl\newx<>pl\manx+absx(fr,fr\actpnt-1) Then
									pl\oldx=pl\newx:pl\oldy=pl\newy
									pl\newx=pl\manx+absx(fr,fr\actpnt-1)
									pl\newy=pl\many+absy(fr,fr\actpnt-1)
								End If
								Exit
							End If
						Next
						Exit
					End If
				Next
			Next
		End If
		If MilliSecs()-coltimer=>ANIMSPEED/2 Then
			coltimer=MilliSecs()
			For pl.player = Each player
				For ani.anim = Each anim
					If ani\player=pl\ID And ani\selected
						For fr.fram = Each fram
							If fr\selected And fr\parent = ani\ID
								pl\HitAngle=ATan2(pl\newx-pl\oldx,pl\newy-pl\oldy)
								;Ch3c|< iF 3y3 h4v3 hi7 jOO
								;If you want to know, I'm only writing that because I am bored
								;and have been working all morning with no breakfast.
								;AGRRRGGGGHHHHH WEEEETABIXXXXX bbl
								Check_Collisions(pl,ani,fr)
								Exit
							End If
						Next
						Exit
					End If
				Next
			Next
		End If
		tween#=Float(MilliSecs()-anitimer)/ANIMSPEED
		
		
		For pl.player = Each player
			If pl\lifebar<pl\life Then pl\lifebar=pl\life
			If pl\lifebar>pl\life And MilliSecs()-pl\lifetimer>400 Then pl\lifebar=pl\lifebar-tween*15
			For ani.anim = Each anim
				If ani\player = pl\ID And ani\selected
					For fr.fram = Each fram
						If fr\selected And fr\parent = ani\ID
							;offmanx is used to state the offset of the stickman before the next
							;frame, while the animation is tweening. It is calculated relative to
							;the current timer so we always get a nice smooth movement.
							
							;Anyway, this little section is to stop fighers from walking thru each other
	
							pl\offmanx=0
							For anib.anim = Each anim
								If anib\ID = pl\nextfr\parent
									If anib\name="run" Or ani\name="leapkick" Or anib\name="leap" Or anib\name="lunge" Or anib\name="flykick" Or anib\name="roll" Then pl\offmanx=30
									If anib\name="gym" Or anib\name="thrown" Then pl\offmanx=20
									If anib\name="walk" Or anib\name="crawl" Or ani\name="triplekick" Or ani\name="spinkick" Or anib\name="jumphit" Or ani\name="jumphit2" Or anib\name="jump" Then pl\offmanx=10
									If anib\name="backstep" Then pl\offmanx=-10
									If anib\name="backflip" Or anib\name="fallback" Or anib\name="rollback" Then pl\offmanx=-20
								End If
							Next
							pl\offmanx=tween*pl\offmanx*pl\lr
							For plb.player = Each player
								If plb\ID<>pl\ID And GameMode<>GAME_REPLAY Then
									For anib.anim = Each anim
										If anib\player = plb\ID And anib\selected
											For frb.fram = Each fram
												If frb\selected And frb\parent = anib\ID
													If pl\manx+pl\offmanx>760 Then pl\manx=760-pl\offmanx
													If pl\manx+pl\offmanx<40 Then pl\manx=40-pl\offmanx
													If anib\name<>"lieback" And anib\name<>"fallback" And anib\name<>"liefront" And ani\name<>"thrown" And ani\name<>"lieback" And ani\name<>"fallback" And ani\name<>"liefront" And anib\name<>"thrown"
														pl\many = TweenVal(PulltoGround(fr,400,1),PulltoGround(pl\nextfr,400,1),tween)
														plb\many = TweenVal(PulltoGround(frb,400,1),PulltoGround(plb\nextfr,400,1),tween)
														If Abs((pl\many+fr\py[0])-(plb\many+frb\py[0]))<20 And pl\offmanx<>0
															While RectsOverlap(pl\manx+pl\offmanx-20,pl\many+fr\py[0]-15,40,30,plb\manx+plb\offmanx-20,plb\many+frb\py[0]-15,40,30)
																
																If pl\manx+pl\offmanx<plb\manx+plb\offmanx Or plb\manx+plb\offmanx+40>760 Then
																	pl\manx=pl\manx-2
																	pl\replx[pl\rpl]=pl\manx
																Else
																	pl\manx=pl\manx+2
																	pl\replx[pl\rpl]=pl\manx
																End If
															Wend
														End If
													End If
												End If
											Next
										End If
									Next
								End If
							Next
						End If
					Next
				End If
			Next
		Next
		
		Color 0,0,0
		For pl.player = Each player
			For ani.anim = Each anim
				If ani\player = pl\ID And ani\selected
					For fr.fram = Each fram
						If fr\selected And fr\parent = ani\ID
	
							;-------- DRAW THE STICKMAN HERE ---------------------------
							;The first frame in the type list is a temporary frame with
							;no parent, and so it is used to calculate display data.
							;The actually coordinates of this frame are calculated by
							;by tweening the 'selected' frame, and the next frame.
							
							;TWEENVAL(a#,b#,t#) and TWEENANGLE(a#,b#,t#) take care of that.
							
							tween#=Float(MilliSecs()-anitimer)/ANIMSPEED
							If tween<0 Then tween=0
							If tween>1 Then tween=1
							
							frnow.fram = First fram
							
							For i=0 To 11
								frnow\pa[i]=TweenAngle(fr\pa[i],pl\nextfr\pa[i],tween)
								frnow\pd[i]=fr\pd[i]
								angpos(frnow,i)
							Next
							
							frnow\py[0] = TweenAngle(fr\py[0],pl\nextfr\py[0],tween)
							
							;Make sure the players cannot walk through each other.
							
							;Make sure we call PulltoGround(fr,400,1) so that the stickman has the
							;sense of gravity and floor-collision.
							pl\many = TweenVal(PulltoGround(fr,400,0.3),PulltoGround(pl\nextfr,400,0.3),tween)
							If pl\ID=1 Then Color 200,180,180 Else Color 180,180,200
							Viewport 0,400,GraphicsWidth(),GraphicsHeight()-400
							DrawStickMan(frnow,pl\manx+pl\offmanx,800-pl\many,pl\lr,-0.3,2)
							Viewport 0,0,GraphicsWidth(),GraphicsHeight()
							pl\many = TweenVal(PulltoGround(fr,400,1),PulltoGround(pl\nextfr,400,1),tween)
							If pl\ID=1 Then Color 80,0,0 Else Color 0,0,80
							DrawStickMan(frnow,pl\manx+pl\offmanx,pl\many,pl\lr,1,2)
						End If
					Next
				End If
			Next
			;HEALTH BARS
			
			If pl\ID Mod 2=1 Then
				Color 128,128,128
				Line 50,70,350,70
				Line 350,50,350,70
				Line 51,71,351,71
				Line 351,51,351,71
				Rect 50,50,pl\lifebar,20,1
				Color 80,0,0
				Rect 50,50,300,20,0
				Rect 50,50,pl\life,20,1
				For i=0 To pl\wins-1
					DrawBlock imgKO,50+i*30,80
				Next
				Color 180,180,180
				Text 51,26,pl\name
				Color 80,0,0
				Text 50,25,pl\name
				DrawBlock imgFlags,pl\manx+pl\offmanx,110,0
			ElseIf pl\ID Mod 2=0 Then
				Color 128,128,128
				Line 450,70,750,70
				Line 750,50,750,70
				Line 451,71,751,71
				Line 751,51,751,71
				Rect 450,50,pl\lifebar,20,1
				Color 0,0,80
				Rect 450,50,300,20,0
				Rect 450,50,pl\life,20,1
				For i=0 To pl\wins-1
					DrawBlock imgKO,750-i*30-ImageWidth(imgKO),80
				Next
				Color 180,180,180
				Text 751-StringWidth(pl\name),26,pl\name
				Color 0,0,80
				Text 750-StringWidth(pl\name),25,pl\name
				DrawBlock imgFlags,pl\manx+pl\offmanx,110,1
			End If
		Next
		For p.particle = Each particle
			Color 255,0,0
			p\yspeed=p\yspeed+0.5
			p\x=p\x+p\xspeed
			p\y=p\y+p\yspeed
			Oval p\x,p\y,p\goresize,p\goresize
			If p\y>400 Then Delete p
		Next
		
		Color 0,0,0
		
		If GameMode=GAME_REPLAY Then
			If (MilliSecs()-GameTimer) Mod 400>200 Then
				DrawBlock imgR,GraphicsWidth()/2-ImageWidth(imgR)/2,10,0
			Else
				DrawBlock imgR,GraphicsWidth()/2-ImageWidth(imgR)/2,10,1
			End If
		End If
		
		Origin 0,0
		Line 0,400,GraphicsWidth(),400
		Flip
	Wend
	
	Return endme
End Function

Function Get_NextFrame.fram(fr.fram,ani.anim,pl.player)
	If GameMode<>GAME_REPLAY Then
		pl\replay.fram[pl\rpl]=fr
		pl\replx[pl\rpl]=pl\manx
		pl\replLR[pl\rpl]=pl\lr
	End If
	pl\rpl=pl\rpl+1
	If pl\rpl>40 Then pl\rpl=0
	If fr\lastframe And ani\name="turn" Then pl\lr=-pl\lr
	If fr\lastframe And ani\name="getup" Then pl\lr=-pl\lr
	offmanx=0
	If ani\name="run" Or ani\name="leap" Or ani\name="leapkick" Or ani\name="lunge" Or ani\name="flykick" Or ani\name="roll" Then offmanx=30
	If ani\name="gym" Or ani\name="thrown" Then offmanx=20
	If ani\name="walk" Or ani\name="crawl" Or ani\name="triplekick" Or ani\name="spinkick" Or ani\name="jump" Or ani\name="jumphit2" Or ani\name="jumphit" Or ani\name="uppercut" Then offmanx=10
	If ani\name="backstep" Then offmanx=-10
	If ani\name="backflip" Or ani\name="fallback" Or ani\name="rollback" Then offmanx=-20
	
	pl\manx=pl\manx+offmanx*pl\lr
	If ani\name="yoga" And pl\life<300 Then pl\life=pl\life+1
	
	;It calculates which frame will be coming up next.
	;The ChangeIt determines whether the animation is going to change,
	;otherwise it goes through the type list until it finds the next frame
	;which has the same parent animation as the current frame.
	frb.fram = After fr
	backbegin=False
	framnxt=fr\framenum
	nxtparent=fr\parent
	
	ChangeIt=0
	If pl\control=CNTRL_AI Then AI_NextMove(fr,ani,pl)
	pl\ChargeDie=pl\ChargeDie+1:If pl\ChargeDie=>11 Then pl\ChargeDie=0:pl\ChargeUp$=""
	If Len(pl\ChargeUp$)>10 Then pl\ChargeUp$=Right(pl\ChargeUp$,10)
	
	ChargeMove$=""
	For i=Len(pl\ChargeUp$) To 1 Step -1
		ChargeMove$=ChargeUpMove(Right(pl\ChargeUp,i),fr,ani,pl)
		If ChangeIt=0 And ChargeMove<>"" Then ChangeIt = ChangeAnim(pl,True,ChargeMove)
		If Len(ChargeMove$)>0 And chargemove<>"RR" And chargemove<>"LL" And chargemove<>"UUU" Then pl\ChargeUp$=""
	Next
	
	;dO 13f7-Ri6h7 c4lcu147iO|\|$ h3r3
	closest=1000
	For plc.player = Each player
		If Abs(pl\manx-plc\manx)<closest And pl\ID<>plc\ID Then
			plb.player = plc.player
			closest=pl\manx-plc\manx
		End If
	Next
	If plb<>Null Then
		If (pl\manx>plb\manx And pl\lr=1) Or (pl\manx<plb\manx And pl\lr=-1)
			If ChangeIt = 0 Then ChangeIt = ChangeAnim(pl,ani\name="wait" Or ani\name="walk","turn")
		End If
	End If

	;KVal(KEY,1)>0 means KeyHit() or KeyDown()
	;KVal(KEY,1)=1 means KeyHit() only
	;KVal(KEY,1)=0 means NOT KeyDown()
	
	If ChangeIt=0 Then ChangeIt = ChangeAnim(pl,KVal(F3,1,pl\ID)>0 And ani\name="wait","blockhi")
	If ChangeIt=0 Then ChangeIt = ChangeAnim(pl,KVal(F3,1,pl\ID)>0 And ani\name="duck","blocklo")
	If ChangeIt=0 Then ChangeIt = ChangeAnim(pl,(KVal(FD,1,pl\ID)>0 Or KVal(BK,1,pl\ID)>0) And ani\name="blockhi","blockmid")
	If ChangeIt=0 Then ChangeIt = ChangeAnim(pl,KVal(DN,1,pl\ID)>0 And Left(ani\name,4)="bloc","blocklo")
	If ChangeIt=0 Then ChangeIt = ChangeAnim(pl,GameMode=GAME_DIE And ani\name="wait","victory")
	If ChangeIt=0 Then ChangeIt = ChangeAnim(pl,KVal(FD,1,pl\ID)>0 And ani\name="wait","walk")
	If ChangeIt=0 Then ChangeIt = ChangeAnim(pl,KVal(FD,1,pl\ID)>0 And ani\name="duck","roll")
	If ChangeIt=0 Then ChangeIt = ChangeAnim(pl,KVal(UP,1,pl\ID)>0 And ani\name="lieback","flipup")
	If ChangeIt=0 Then ChangeIt = ChangeAnim(pl,KVal(UP,1,pl\ID)>0 And ani\name="liefront","getup")
	If ChangeIt=0 Then ChangeIt = ChangeAnim(pl,KVal(DN,1,pl\ID)=1 And ani\name="lieback","duck")
	If ChangeIt=0 Then ChangeIt = ChangeAnim(pl,KVal(DN,1,pl\ID)>0 And ani\name="wait","duck")
	If ChangeIt=0 Then ChangeIt = ChangeAnim(pl,KVal(BK,1,pl\ID)>0 And ani\name="wait","backstep")
	If ChangeIt=0 Then ChangeIt = ChangeAnim(pl,KVal(UP,1,pl\ID)>0 And KVal(FD,1,pl\ID)>0 And ani\name="walk","jump")
	If ChangeIt=0 Then ChangeIt = ChangeAnim(pl,KVal(UP,1,pl\ID)>0 And ani\name="run","leap")
	If ChangeIt=0 Then ChangeIt = ChangeAnim(pl,KVal(DN,1,pl\ID)>0 And ani\name="run","roll")
	If ChangeIt=0 Then ChangeIt = ChangeAnim(pl,KVal(F2,1,pl\ID)=1 And ani\name="run","leapkick")
	If ChangeIt=0 Then ChangeIt = ChangeAnim(pl,KVal(UP,1,pl\ID)>0 And KVal(FD,1,pl\ID)>0 And ani\name="wait","jump")
	If ChangeIt=0 Then ChangeIt = ChangeAnim(pl,KVal(UP,1,pl\ID)=1 And KVal(BK,1,pl\ID)>0 And ani\name="wait","backflip")
	If ChangeIt=0 Then ChangeIt = ChangeAnim(pl,KVal(UP,1,pl\ID)>0 And ani\name="wait","jumpup")
	If ChangeIt=0 Then ChangeIt = ChangeAnim(pl,KVal(UP,1,pl\ID)>0 And KVal(BK,1,pl\ID)>0 And ani\name="backstep","backflip")
	If ChangeIt=0 Then ChangeIt = ChangeAnim(pl,KVal(BK,1,pl\ID)>0 And ani\name="lieback","rollback")
	If ChangeIt=0 Then ChangeIt = ChangeAnim(pl,KVal(F2,1,pl\ID)=1 And (ani\name="wait" Or ani\name="walk"),"hit3")
	If ChangeIt=0 Then ChangeIt = ChangeAnim(pl,KVal(F1,1,pl\ID)=1 And KVal(FD,1,pl\ID)>0 And (ani\name="wait" Or ani\name="walk"),"hit2")
	If ChangeIt=0 Then ChangeIt = ChangeAnim(pl,KVal(F1,1,pl\ID)=1 And (ani\name="wait" Or ani\name="walk"),"hit1")
	If ChangeIt=0 Then ChangeIt = ChangeAnim(pl,KVal(F2,1,pl\ID)=1 And ani\name="duck","lowhit1")
	If ChangeIt=0 Then ChangeIt = ChangeAnim(pl,KVal(F1,1,pl\ID)=1 And ani\name="duck","lowhit2")
	If ChangeIt=0 Then ChangeIt = ChangeAnim(pl,KVal(FD,1,pl\ID)=0 And ani\name="run","wait")
	If ChangeIt=0 Then ChangeIt = ChangeAnim(pl,KVal(BK,1,pl\ID)=0 And ani\name="backstep","wait")
	If ChangeIt=0 Then ChangeIt = ChangeAnim(pl,KVal(FD,1,pl\ID)=0 And ani\name="walk","wait")
	If ChangeIt=0 Then ChangeIt = ChangeAnim(pl,KVal(UP,1,pl\ID)=0 And ani\name="yoga","wait")
	If ChangeIt=0 Then ChangeIt = ChangeAnim(pl,KVal(FD,1,pl\ID)=0 And ani\name="crawl","duck")
	If ChangeIt=0 Then ChangeIt = ChangeAnim(pl,KVal(DN,1,pl\ID)=0 And ani\name="crawl","wait")
	If ChangeIt=0 Then ChangeIt = ChangeAnim(pl,KVal(DN,1,pl\ID)=0 And ani\name="duck","wait")
	If ChangeIt=0 Then ChangeIt = ChangeAnim(pl,KVal(FD,1,pl\ID)=0 And KVal(BK,1,pl\ID)=0 And ani\name="blockmid","blockhi")
	If ChangeIt=0 Then ChangeIt = ChangeAnim(pl,KVal(DN,1,pl\ID)=0 And (KVal(FD,1,pl\ID)>0 Or KVal(BKT,1,pl\ID)>0) And ani\name="blocklo","blockmid")
	If ChangeIt=0 Then ChangeIt = ChangeAnim(pl,KVal(DN,1,pl\ID)=0 And ani\name="blocklo","blockhi")
	If ChangeIt=0 Then ChangeIt = ChangeAnim(pl,KVal(F3,1,pl\ID)=0 And ani\name="blocklo","duck")
	If ChangeIt=0 Then ChangeIt = ChangeAnim(pl,KVal(F3,1,pl\ID)=0 And Left(ani\name,4)="bloc","wait")
	If ChangeIt=0 Then ChangeIt = ChangeAnim(pl,fr\lastframe And Left(ani\name,3)="hit","wait")
	If ChangeIt=0 Then ChangeIt = ChangeAnim(pl,fr\lastframe And KVal(DN,1,pl\ID)>0 And Left(ani\name,3)="hit","duck")
	If ChangeIt=0 Then ChangeIt = ChangeAnim(pl,fr\lastframe And KVal(UP,1,pl\ID)>0 And Left(ani\name,3)="hit","jump")
	If ChangeIt=0 Then ChangeIt = ChangeAnim(pl,fr\lastframe And Left(ani\name,6)="lowhit","duck")
	If ChangeIt=0 Then ChangeIt = ChangeAnim(pl,fr\lastframe And ani\name="bendkick","wait")
	If ChangeIt=0 Then ChangeIt = ChangeAnim(pl,fr\lastframe And ani\name="gym","roll")
	If ChangeIt=0 Then ChangeIt = ChangeAnim(pl,fr\lastframe And ani\name="lunge","roll")
	If ChangeIt=0 Then ChangeIt = ChangeAnim(pl,fr\lastframe And KVal(FD,1,pl\ID)=0 And ani\name="roll","duck")
	If ChangeIt=0 Then ChangeIt = ChangeAnim(pl,fr\lastframe And KVal(DN,1,pl\ID)=0 And KVal(FD,1,pl\ID)>0 And ani\name="roll","run")
	If ChangeIt=0 Then ChangeIt = ChangeAnim(pl,fr\lastframe And ani\name="backkick","wait")
	If ChangeIt=0 Then ChangeIt = ChangeAnim(pl,fr\lastframe And ani\name="leap","run")
	If ChangeIt=0 Then ChangeIt = ChangeAnim(pl,fr\lastframe And ani\name="backflip","backstep")
	If ChangeIt=0 Then ChangeIt = ChangeAnim(pl,fr\lastframe And ani\name="jumpup","wait")
	If ChangeIt=0 Then ChangeIt = ChangeAnim(pl,fr\lastframe And ani\name="jump","walk")
	If ChangeIt=0 Then ChangeIt = ChangeAnim(pl,fr\lastframe And ani\name="doublekick","wait")
	If ChangeIt=0 Then ChangeIt = ChangeAnim(pl,fr\lastframe And ani\name="flykick","roll")
	If ChangeIt=0 Then ChangeIt = ChangeAnim(pl,fr\lastframe And ani\name="uppercut","wait")
	If ChangeIt=0 Then ChangeIt = ChangeAnim(pl,fr\lastframe And ani\name="turbohit","wait")
	If ChangeIt=0 Then ChangeIt = ChangeAnim(pl,fr\lastframe And ani\name="kickupdn","wait")
	If ChangeIt=0 Then ChangeIt = ChangeAnim(pl,fr\lastframe And ani\name="playdead","lieback")
	If ChangeIt=0 Then ChangeIt = ChangeAnim(pl,fr\lastframe And ani\name="fallback","lieback")
	If ChangeIt=0 Then ChangeIt = ChangeAnim(pl,fr\lastframe And ani\name="flipup","wait")
	If ChangeIt=0 Then ChangeIt = ChangeAnim(pl,fr\lastframe And ani\name="throw","wait")
	If ChangeIt=0 Then ChangeIt = ChangeAnim(pl,fr\lastframe And ani\name="thrown","liefront")
	If ChangeIt=0 Then ChangeIt = ChangeAnim(pl,fr\lastframe And ani\name="getup","wait")
	If ChangeIt=0 Then ChangeIt = ChangeAnim(pl,fr\lastframe And ani\name="bow","wait")
	If ChangeIt=0 Then ChangeIt = ChangeAnim(pl,fr\lastframe And ani\name="owhi","wait")
	If ChangeIt=0 Then ChangeIt = ChangeAnim(pl,fr\lastframe And ani\name="owmid","wait")
	If ChangeIt=0 Then ChangeIt = ChangeAnim(pl,fr\lastframe And ani\name="owlo","wait")
	If ChangeIt=0 Then ChangeIt = ChangeAnim(pl,fr\lastframe And ani\name="rollback","wait")
	If ChangeIt=0 Then ChangeIt = ChangeAnim(pl,fr\lastframe And ani\name="turn","wait")
	If ChangeIt=0 Then ChangeIt = ChangeAnim(pl,fr\lastframe And ani\name="jumphit","wait")
	If ChangeIt=0 Then ChangeIt = ChangeAnim(pl,fr\lastframe And ani\name="jumphitup","wait")
	If ChangeIt=0 Then ChangeIt = ChangeAnim(pl,fr\lastframe And ani\name="jumphit2","wait")
	If ChangeIt=0 Then ChangeIt = ChangeAnim(pl,fr\lastframe And ani\name="jumphitup2","wait")
	If ChangeIt=0 Then ChangeIt = ChangeAnim(pl,fr\lastframe And ani\name="taunt","wait")
	If ChangeIt=0 Then ChangeIt = ChangeAnim(pl,fr\lastframe And ani\name="triplekick","wait")
	If ChangeIt=0 Then ChangeIt = ChangeAnim(pl,fr\lastframe And ani\name="spinkick","wait")
	If ChangeIt=0 Then ChangeIt = ChangeAnim(pl,fr\lastframe And ani\name="whiplash","wait")
	If ChangeIt=0 Then ChangeIt = ChangeAnim(pl,fr\lastframe And ani\name="leapkick","run")
	If ChangeIt=0 Then ChangeIt = ChangeAnim(pl,fr\lastframe And ani\name="flickup","wait")

	If ChangeIt>0 Then
		nxtparent=ChangeIt-1
		framnxt=0
		frb.fram = First fram
	End If
	
	;Go through all the frames until we get to the one we want. If it's NULL then
	;we must be at the end of the Type list, so we'd start from the beginning and carry on.
	If frb=Null Then
		frb.fram = First fram
		backbegin=True
		framnxt=0
	End If
	While frb\parent<>nxtparent Or (framnxt<=ani\loopfrom And backbegin)
		frb.fram = After frb
		If frb=Null Then
			frb=First fram
			framnxt=0:backbegin=True
		End If
		If frb\parent=ani\id Then framnxt=framnxt+1
	Wend
	
	For i=0 To 10
		;Reset Key states for the next frame
		If KVal(i,1,pl\ID)>0 Then KVal(i,1,pl\ID)=KVal(i,1,pl\ID)+1
		If KVal(i,1,pl\ID)>0 Then KVal(i,1,pl\ID)=KVal(i,1,pl\ID)+1
	Next
	
	Return frb
End Function


Function ChangeAnim(pl.player,condition,animname$)
	If condition=True
		For anib.anim = Each anim
			If anib\name$=animname$ And anib\Player = pl\ID
				;anib\selected=True
				Return anib\ID+1
			End If
		Next
	End If
End Function


Function Init_Keys()
	For i=0 To 4
		KVal(UP,0,i)=200
		KVal(DN,0,i)=208
		KVal(FD,0,i)=205
		KVal(BK,0,i)=203
		KVal(F1,0,i)=16
		KVal(F2,0,i)=17
		KVal(F3,0,i)=18
	Next
	
End Function


Function Load_Media()
	sndHit=LoadSound("sounds\hit.wav")
	sndSwish=LoadSound("sounds\woosh.wav")
	sndDrop=LoadSound("sounds\drop.wav")
	sndGong=LoadSound("sounds\gong.wav")
	sndYa=LoadSound("sounds\ya.wav")
	sndYa2=LoadSound("sounds\ya2.wav")
	sndTick=LoadSound("sounds\tick.wav")
	sndMee=LoadSound("sounds\mee.wav")
	sndGdBye=LoadSound("sounds\gdbye.wav")
	imgR=LoadAnimImage("images\r.png",64,64,0,2)
	imgFight=LoadImage("images\fight.png")
	imgKO=LoadImage("images\ko.png")
	imgTitle=LoadImage("images\title.jpg")
	imgStickFace=LoadAnimImage("images\stickface.jpg",128,128,0,8)
	imgInputs=LoadAnimImage("images\inputs.png",128,128,0,3)
	imgButtons=LoadAnimImage("images\buttons.png",256,64,0,6)
	imgHands=LoadAnimImage("images\hands.png",25,19,0,2)
	imgYesNo=LoadAnimImage("images\yesno.png",64,64,0,2)
	imgFlags=LoadAnimImage("images\flags.png",10,16,0,2)
	imgTally=LoadAnimImage("images\tally.png",128,64,0,5)
	imgVS=LoadImage("images\vs.jpg")
	MidHandle imgFlags
	MidHandle imgButtons
	MidHandle imgFight
	MidHandle imgHands
	MidHandle imgTally
	MaskImage imgFight,255,255,255
	MaskImage imgButtons,255,255,255
	MaskImage imgTitle,255,255,255
	
	fntBig=LoadFont("Arial",48,True,False,False)
	fntSmall=LoadFont("Arial",14,False,False,False)
	fntMedium=LoadFont("Arial",24,False,False,False)
	
	f=ReadFile("config.dat")
	If f<>0
		bouts=ReadByte(f)
		gorelevel=ReadByte(f)
		battlepower=ReadByte(f)
		CloseFile f
	End If
	
End Function


Function Get_KeyEvents(pl.player)
	If pl\control=CNTRL_KEY Then
		For i=0 To 10
			If (i<>FD And i<>BK) Or pl\lr=1
				If KeyDown(KVal(i,0,pl\ID))
					If KVal(i,1,pl\ID)=0
						KVal(i,1,pl\ID)=1
						If MilliSecs()-KVal(i,2,pl\ID)<400 Then pl\Chargeup=pl\chargeup+"x"
						If i=UP Then pl\ChargeUp$=pl\ChargeUp$+"U"
						If i=DN Then pl\ChargeUp$=pl\ChargeUp$+"D"
						If i=BK Then pl\ChargeUp$=pl\ChargeUp$+"B"
						If i=FD Then pl\ChargeUp$=pl\ChargeUp$+"F"
						If i>=F1 Then pl\ChargeUp$=pl\ChargeUp$+(i-F1+1)
						pl\ChargeDie=0
					End If
				ElseIf KVal(i,1,pl\ID)=>1
					KVal(i,2,pl\ID)=MilliSecs()
					If KVal(i,1,pl\ID)>1 Then KVal(i,1,pl\ID)=0
				End If
			Else
				If i=FD Then j=BK Else j=FD
				If KeyDown(KVal(i,0,pl\ID)) 
					If KVal(j,1,pl\ID)=0
						KVal(j,1,pl\ID)=1
						If MilliSecs()-KVal(j,2,pl\ID)<400 Then pl\Chargeup=pl\chargeup+"x"
						If j=BK Then pl\ChargeUp$=pl\ChargeUp$+"B"
						If j=FD Then pl\ChargeUp$=pl\ChargeUp$+"F"
						pl\ChargeDie=0
					End If
				ElseIf KVal(j,1,pl\ID)=>1
					KVal(j,2,pl\ID)=MilliSecs()
					If KVal(j,1,pl\ID)>1 Then KVal(j,1,pl\ID)=0
				End If
			End If
		Next
	ElseIf pl\control=CNTRL_JOY
		i=UP
		If JoyYDir()<-.5 Then
			If KVal(i,1,pl\ID)=0
				KVal(i,1,pl\ID)=1
				If MilliSecs()-KVal(i,2,pl\ID)<400 Then pl\Chargeup=pl\chargeup+"x"
				pl\ChargeUp=pl\ChargeUp+"U"
				pl\ChargeDie=0
			End If
		ElseIf KVal(i,1,pl\ID)=>1
			KVal(i,2,pl\ID)=MilliSecs()
			If KVal(i,1,pl\ID)>1 Then KVal(i,1,pl\ID)=0
		End If
		i=DN
		If JoyYDir()>.5 Then
			If KVal(i,1,pl\ID)=0
				KVal(i,1,pl\ID)=1
				If MilliSecs()-KVal(i,2,pl\ID)<400 Then pl\Chargeup=pl\chargeup+"x"
				pl\ChargeUp=pl\ChargeUp+"D"
				pl\ChargeDie=0
			End If
		ElseIf KVal(i,1,pl\ID)=>1
			KVal(i,2,pl\ID)=MilliSecs()
			If KVal(i,1,pl\ID)>1 Then KVal(i,1,pl\ID)=0
		End If
		i=BK
		If (JoyXDir()<-.5 And pl\lr=1) Or (JoyXDir()>.5 And pl\lr=-1)
			If KVal(i,1,pl\ID)=0
				KVal(i,1,pl\ID)=1
				If MilliSecs()-KVal(i,2,pl\ID)<400 Then pl\Chargeup=pl\chargeup+"x"
				pl\ChargeUp=pl\ChargeUp+"B"
				pl\ChargeDie=0
			End If
		ElseIf KVal(i,1,pl\ID)=>1
			KVal(i,2,pl\ID)=MilliSecs()
			If KVal(i,1,pl\ID)>1 Then KVal(i,1,pl\ID)=0
		End If
		i=FD
		If (JoyXDir()>.5 And pl\lr=1) Or (JoyXDir()<-.5 And pl\lr=-1) Then
			If KVal(i,1,pl\ID)=0
				KVal(i,1,pl\ID)=1
				If MilliSecs()-KVal(i,2,pl\ID)<400 Then pl\Chargeup=pl\chargeup+"x"
				pl\ChargeUp=pl\ChargeUp+"F"
				pl\ChargeDie=0
			End If
		ElseIf KVal(i,1,pl\ID)=>1
			KVal(i,2,pl\ID)=MilliSecs()
			If KVal(i,1,pl\ID)>1 Then KVal(i,1,pl\ID)=0
		End If
		For i=F1 To F3
			If JoyDown(i-F1+1) 
				If KVal(i,1,pl\ID)=0
					KVal(i,1,pl\ID)=1
					If MilliSecs()-KVal(i,2,pl\ID)<400 Then pl\Chargeup=pl\chargeup+"x"
					pl\ChargeUp=pl\ChargeUp+(i-F1+1)
					pl\ChargeDie=0
				End If
			ElseIf KVal(i,1,pl\ID)=>1
				KVal(i,2,pl\ID)=MilliSecs()
				If KVal(i,1,pl\ID)>1 KVal(i,1,pl\ID)=0
			End If
		Next
	End If
End Function

Function ChargeUpMove$(MoveIt$,fr.fram,ani.anim,pl.player)
	;D=Down
	;R=Right (forward)
	;L=Left  (backward)
	;U=Up
	;1 -> ?  (fire button)
	
	Select MoveIt$
	Case "B3"
		If ani\name="wait" Or ani\name="walk" Or ani\name="backstep" Then Return "blockmid" Else Return "  "
	Case "1"
		If ani\name="jumpup" And fr\framenum=ani\totalframes/2 Then Return "jumphitup"
		If ani\name="jump" And fr\framenum=ani\totalframes/2-1 Then Return "jumphit"
	Case "2"
		If ani\name="jumpup" And fr\framenum=ani\totalframes/2 Then Return "jumphitup2"
		If ani\name="jump" And fr\framenum=ani\totalframes/2-1 Then Return "jumphit2"
	Case "U2"
		If ani\name="leap" Or ani\name="triplekick" And fr\framenum=ani\totalframes/2+2 Then Return "flykick"
	Case "F2"
		If ani\name="triplekick" And fr\framenum=ani\totalframes/2+1 Then Return "spinkick"
		If ani\name="jump" And fr\framenum=ani\totalframes/2-1 Then Return "spinkick"
	Case "12B"
		If ani\name="wait" Or Left(ani\name,3)="hit" Or ani\name="backstep" Or ani\name="walk" Then Return "throw" Else Return "  "
	Case "2x2U"
		If ani\name="duck" Or Left(ani\name,3)="low" Or ani\name="lieback" Then Return "flickup"
	Case "DxDxD"
		If ani\name="duck" Then Return "playdead" Else Return "   "
	Case "12F"
		If ani\name="wait" Or ani\name="walk" Or Left(ani\name,3)="hit" Then Return "turbohit" Else Return "  "
	Case "DB2"
		If ani\name="wait" Or ani\name="walk" Or ani\name="crouch" Or Left(ani\name,3)="low" Or Left(ani\name,3)="hit" Or ani\name="backstep" Or ani\name="run" Or ani\name="roll" Then Return "triplekick" Else Return "  "
	Case "U2x2"
		If ani\name="jumpup" And fr\framenum=ani\totalframes/2 Then Return "doublekick"
	Case "UD2"
		If (ani\name="jumpup" And fr\framenum<=3) Or (ani\name="triplekick" And fr\framenum=ani\totalframes/2+2) Then Return "kickupdn"
	Case "FB2"
		If ani\name="wait" Or ani\name="walk" Or ani\name="backstep" Or Left(ani\name,3)="hit" Then Return "backkick" Else Return "  "
	Case "BF2"
		If ani\name="wait" Or ani\name="walk" Or ani\name="backstep" Or Left(ani\name,3)="hit" Then Return "whiplash" Else Return "  "
	Case "UxUxU"
		If ani\name="wait" Or ani\name="jumpup" Then Return "yoga" Else Return "  "
	Case "1x1D"
		If ani\name="run" Or (ani\name="triplekick" And fr\framenum=ani\totalframes/2+2) Then Return "gym"
	Case "1x1U"
		If ani\name="run" Or (ani\name="triplekick" And fr\framenum=ani\totalframes/2+2) Then Return "lunge"
	Case "B2x2"
		If ani\name="backstep" Or ani\name="walk" Or ani\name="wait" Or Left(ani\name,3)="hit" Then Return "bendkick" Else Return "  "
	Case "DF1"
		If ani\name="wait" Or ani\name="walk" Or ani\name="duck" Or ani\name="roll" Then Return "uppercut" Else Return "  "
	Case "FxF"
		If ani\name="wait" Or ani\name="walk" Then Return "run" Else Return "   "
	Case "BxB"
		If ani\name="backstep" Or ani\name="wait" Then Return "backflip" Else Return "   "
	Case "B2"
		If ani\name="backstep" Or ani\name="walk" Or ani\name="wait" Then Return "hit4"
	Case "BFBFBF"
		If ani\name="walk" Or ani\name="wait" Or ani\name="backstep" Then Return "taunt"
	End Select
	
End Function


Function Create_Player.player(name$)
	ID=1
	For pl.player = Each player
		If pl\ID=ID Then ID=pl\ID+1
	Next
	pl.player = New player
	pl\ID=ID
	pl\name=name$
	pl\lr=(pl\ID Mod 2)*2-1
	pl\many=200
	pl\manx=200+400*((pl\ID-1) Mod 2)+80*((pl\ID-1)/2)*((pl\ID Mod 2)*2-1)
	pl\life=300
	For ani.anim = Each anim
		If ani\player=pl\ID And ani\name="bow"
			ani\selected=True
			For fr.fram = Each fram
				If fr\parent = ani\ID Then
					fr\selected=True
					pl\nextfr.fram = Get_NextFrame(fr,ani,pl)
					Exit
				End If
			Next
			Exit
		End If
	Next
	pl\voice=Rand(20000,32000)
	Return pl
	
End Function


Function Check_Collisions(pl.player,ani.anim,fr.fram)
	If fr\actpnt>0 Then
		xx=absx(fr,fr\actpnt-1)*pl\lr+pl\manx+pl\offmanx
		yy=absy(fr,fr\actpnt-1)+pl\many
		For plb.player = Each player
			If plb\ID <> pl\ID
				For anib.anim = Each anim
					If anib\player = plb\ID And anib\selected
						For frb.fram = Each fram
							If frb\parent = anib\ID And frb\selected
								ChangeIt = 0
								If (ani\name<>"fallback" And ani\name<>"thrown" And ani\name<>"flipup" And ani\name<>"getup" And anib\name<>"lieback" And anib\name<>"liefront") And ((Left(ani\name,3)<>"hit" And Left(ani\name,3)<>"low") Or anib\name<>"fallback")
									For i=0 To 11
										If Sqr((xx-(absx(frb,i)*plb\lr+plb\manx+plb\offmanx))^2+(yy-(absy(frb,i)+plb\many))^2)<15 Then
											If ani\name="throw"
												If i>4 And anib\name<>"thrown" Then
													ChangeIt = ChangeAnim(plb,anib\name="wait" Or anib\name="walk" Or anib\name="run" Or Left(anib\name,3)="hit" Or Left(anib\name,2)="ow" Or Left(anib\name,4)="fall","thrown")
													If ChangeIt>0 And MilliSecs()-pl\Throwtimer>ANIMSPEED
														plb\life=plb\life-30*battlepower
														plb\lifetimer=MilliSecs()
														pl\throwtimer=MilliSecs()
													End If
												End If
											ElseIf (i<5 And i>0 And anib\name<>"blocklo") Or (i>5 And anib\name<>"blockhi") Or ((i=5 Or i=0) And anib\name<>"blockmid")
												If fr\py[0]<0
													;If player is attacking with these..
													ChangeIt = ChangeAnim(plb,True,"fallback")
													plb\life=plb\life-6*battlepower
													plb\lifetimer=MilliSecs()
												ElseIf anib\name="gym" Or (frb\py[0]<0 And ani\name<>"run")
													;If hit player is in the middle of one of these..
													ChangeIt = ChangeAnim(plb,True,"fallback")
													plb\life=plb\life-4*battlepower
													plb\lifetimer=MilliSecs()
												Else
													If i<5 And i>0 Then
														ChangeIt = ChangeAnim(plb,True,"owlo")
													ElseIf i>5 Then
														ChangeIt = ChangeAnim(plb,True,"owhi")
													Else
														ChangeIt = ChangeAnim(plb,True,"owmid")
													End If
													plb\life=plb\life-4*battlepower
													plb\lifetimer=MilliSecs()
												End If
												For j=1 To (gorelevel-1)*2.5
													p.particle = New particle
													p\x=absx(frb,i)*plb\lr+plb\manx
													p\y=absy(frb,i)+plb\many
													p\xspeed=Sin(pl\hitangle+Rand(-7*gorelevel,7*gorelevel))*3
													p\yspeed=Cos(pl\hitangle+Rand(-7*gorelevel,7*gorelevel))*3
													p\yspeed=p\yspeed-3
													p\goresize#=Rnd(1,2)*(gorelevel^0.4)
												Next
												If MilliSecs()-pl\hitTimer>ANIMSPEED*.8
													chnHit=PlaySound(sndHit)
													pl\hitTimer=MilliSecs()
													ChannelPitch chnHit,Rand(10000,18000)*100/((ANIMSPEED-100)/6+100)
												End If
											End If
											If plb\life=<0 And GameMode<>GAME_REPLAY Then
												If ChangeIt<>ChangeAnim(plb,True,"thrown") Then ChangeIt=ChangeAnim(plb,True,"fallback")
												GameMode=GAME_DIE
												GameTimer=MilliSecs()
												If plb\life>-100 Then
													pl\wins=pl\wins+1
													plb\life=-100
												End If
												For j=0 To 10
													KVal(j,1,pl\ID)=0
													KVal(j,1,plb\ID)=0
												Next
											End If
											If ChangeIt > 0
												nxtparent = ChangeIt-1
												plb\nextfr.fram = First fram
												While plb\nextfr\parent<>nxtparent
													plb\nextfr.fram = After plb\nextfr
												Wend
											End If
											Exit
										EndIf
									Next
								End If
							End If
						Next
					End If
				Next
			End If
		Next
	End If
End Function


Function AI_NextMove(fr.fram,ani.anim,pl.player)
	closest=1000
	For plc.player = Each player
		If Abs(pl\manx-plc\manx)<closest And pl\ID<>plc\ID Then
			plb.player = plc.player
			closest=pl\manx-plc\manx
		End If
	Next
	If GameMode=GAME_PLAY Then
		If Abs(plb\manx-pl\manx)>200 Then
			If Rnd(1)<0.2 Then
				pl\chargeup=pl\chargeup+"FxF"
				KVal(FD,1,pl\ID)=1
			End If
			If Rnd(1)<0.5 Then
				KVal(FD,1,pl\ID)=1
			End If
			If ani\name="run" And Rnd(1)<0.2 Then
				KVal(UP,1,pl\ID)=1
				pl\chargeup=pl\chargeup+"U"
			End If
			If (pl\lr=1 And plb\manx<pl\manx) Or (pl\lr=-1 And plb\manx>pl\manx)
				KVal(FD,1,pl\ID)=0
				KVal(UP,1,pl\ID)=0
				KVal(DN,1,pl\ID)=0
				KVal(BK,1,pl\ID)=0
			End If
			If Rnd(1)<0.5 Then
				KVal(BK,1,pl\ID)=0
			End If
			If Rnd(1)<0.3 And pl\life<200 Then
				KVal(UP,1,pl\ID)=1
				pl\chargeup=pl\chargeup+"UxUxU"
			End If
			If Rnd(1)<0.15 Then
				KVal(UP,1,pl\ID)=0
			End If
		ElseIf Abs(plb\manx-pl\manx)<=200 Then
			If ani\name="yoga" And Rnd(1)<0.3 Then
				KVal(UP,1,pl\ID)=0
			End If
			If Rnd(1)<0.3 Then
				KVal(FD,1,pl\iD)=1
				pl\chargeup=pl\chargeup+"F"
			End If
			If Rnd(1)<0.3 Then
				KVal(FD,1,pl\iD)=0
			End If
			If Rnd(1)<0.05 Then
				KVal(UP,1,pl\ID)=1
				pl\chargeup=pl\chargeup+"U"
			End If
			If Rnd(1)<0.1 Then
				KVal(F1,1,pl\ID)=1
				pl\chargeup=pl\chargeup+"1"
			End If
			If Rnd(1)<0.1 Then
				KVal(F2,1,pl\ID)=1
				pl\chargeup=pl\chargeup+"2"
			End If
			If (pl\lr=1 And plb\manx<pl\manx) Or (pl\lr=-1 And plb\manx>pl\manx)
				KVal(FD,1,pl\ID)=0
				KVal(UP,1,pl\ID)=0
				KVal(DN,1,pl\ID)=0
				KVal(BK,1,pl\ID)=0
			End If
			If Rnd(1)<0.4 Then
				KVal(BK,0,pl\ID)=0
			End If
		End If
		If Abs(plb\manx-pl\manx)<60 Then
			If ani\name="yoga" Then
				KVal(UP,1,pl\ID)=0
			End If
			If ani\name="run" Then
				KVal(FD,1,pl\ID)=0
			End If
			If Rnd(1)<0.4 Then
				KVal(F1,1,pl\ID)=1
				pl\chargeup=pl\chargeup+"1"
			End If
			If Rnd(1)<0.4 Then
				KVal(F2,1,pl\ID)=1
				pl\chargeup=pl\chargeup+"2"
			End If
			If Rnd(1)<0.05 Then
				KVal(UP,1,pl\ID)=1
				pl\chargeup=pl\chargeup+"U"
			End If
			If Rnd(1)<0.15 Then
				KVal(DN,1,pl\ID)=1
				pl\chargeup=pl\chargeup+"D"
			End If
			If Rnd(1)<0.4 Then
				KVal(FD,1,pl\ID)=1
				pl\chargeup=pl\chargeup+"F"
			End If
			If Rnd(1)<0.3 Then
				KVal(BK,1,pl\ID)=1
				pl\chargeup=pl\chargeup+"B"
			End If
			If Rnd(1)<0.4 Then
				KVal(UP,1,pl\ID)=0
				KVal(DN,1,pl\ID)=0
			End If
			If Rnd(1)<0.1 Or (pl\lr=1 And plb\manx<pl\manx) Or (pl\lr=-1 And plb\manx>pl\manx) Then
				KVal(FD,1,pl\ID)=0
				KVal(BK,1,pl\ID)=0
			End If
		End If
		If Abs(plb\manx-pl\manx)<40 Then
			idea#=Rnd(1)
			If idea<0.04
				pl\chargeup=pl\chargeup+"BF2"
			ElseIf idea<0.08
				pl\chargeup=pl\chargeup+"FB2"
			ElseIf idea<0.12
				pl\chargeup=pl\chargeup+"12B"
			ElseIf idea<0.16
				pl\chargeup=pl\chargeup+"12F"
			ElseIf idea<0.26
				pl\chargeup=pl\chargeup+"DB2"
			ElseIf idea<0.3
				pl\chargeup=pl\chargeup+"DF1"
			End If
		End If
		If ani\name="jumpup" Or ani\name="jump" Or ani\name="leap" Or ani\name="backflip" Then
			KVal(UP,1,pl\ID)=0
		End If
		
		If ani\name="lieback" Or ani\name="liefront" Then
			idea#=Rnd(1)
			If idea<0.3 Then
				KVal(UP,1,pl\ID)=1
			ElseIf idea<0.9 Then
				KVal(BK,1,pl\ID)=1
			ElseIf idea<1 Then
				pl\chargeup=pl\chargeup+"2x2U"
			End If
		End If
		
		If ani\name="run" Then
			idea#=Rnd(1)
			If idea<0.03 Then
				pl\chargeup=pl\chargeup+"1x1D"
			ElseIf idea<0.06 Then
				pl\chargeup=pl\chargeup+"1x1U"
			ElseIf idea<0.2 Then
				pl\chargeup=pl\chargeup+"2"
			ElseIf idea<0.25 Then
				pl\chargeup=pl\chargeup+"U2"
				KVal(UP,1,pl\ID)=1
			End If
		End If
		
		If ani\name="jumpup" Then
			idea#=Rnd(1)
			If idea<0.1 Then
				pl\chargeup=pl\chargeup+"U2x2"
				pl\chargedie=0
			ElseIf idea<0.2 Then
				pl\chargeup=pl\chargeup+"UD2"
				pl\chargedie=0
			End If
		End If
		
		If ani\name="triplekick" Then
			idea#=Rnd(1)
			If idea<0.1
				pl\chargeup=pl\chargeup+"1x1D"
			ElseIf idea<0.2
				pl\chargeup=pl\chargeup+"1x1U"
			ElseIf idea<0.4
				pl\chargeup=pl\chargeup+"U2"
			ElseIf idea<0.6
				pl\chargeup=pl\chargeup+"F2"
			End If
		End If
		
		For anib.anim = Each anim
			If anib\player = plb\ID And anib\selected
				If ani\name="yoga" Then
					If Rnd(1)<0.3 And Abs(plb\manx-pl\manx)>30 Then
						pl\chargeup=pl\chargeup+"FxF"
						KVal(FD,1,pl\ID)=1
					ElseIf Rnd(1)<0.3 Then
						If ani\name="run" Then
							KVal(FD,1,pl\ID)=1
						Else
							KVal(FD,1,pl\ID)=1
						End If
						pl\chargeup=pl\chargeup+"F"
					End If
				End If
			End If
		Next
	Else
		For i=0 To 10
			KVal(i,1,pl\ID)=0
		Next
	End If

End Function


.MessageData
Data 2
Data "You're pathetic! Go home!"
Data "Some people are just naturally gifted... You're not one of them."
Data "I'm the strongest stick in the world!!"
Data "You should think twice before underestimating my Superstick abilities!"
Data "I pity the fool who thinks he's stronger than Mr Stick!"
Data "Why don't you just wimp out and go home?"
Data "If you'd thought about this fight better, perhaps you wouldn't have died so quickly."
Data "Don't feel bad about the fact that I'm smarter than you.."
